(** Time-stamp: <modified the 11/12/2008 (at 15:34) by Erwan Jahier> *)

type typer = Eff.type_ Predef.evaluator

exception EvalType_error of string
val type_error : Eff.type_ list -> string -> 'a
val arity_error : 'a list -> string -> 'b


(*  Provides the type profile of predef operators. More precisely, given an operator
    and a list of types, This function checks that the provided types are ok, and
    returns the list of the operator output types.
*)
val f : Predef.op -> Lxm.t -> Eff.static_arg list -> typer


(* Does not work for NOR_n and DIESE_n! *)
val make_node_exp_eff : 
  bool option -> Predef.op -> Lxm.t -> Eff.static_arg list -> Eff.node_exp


type node_profile = (Ident.t * Eff.type_) list * (Ident.t * Eff.type_) list

val fillred_profile : Lxm.t -> Eff.static_arg list -> node_profile
val map_profile     : Lxm.t -> Eff.static_arg list -> node_profile
val boolred_profile : Lxm.t -> Eff.static_arg list -> node_profile
